	.file	"encoder.cpp"
	.text
	.align 2
	.globl	_ZN3tga7EncoderC2EPNS_13FileInterfaceE
	.type	_ZN3tga7EncoderC2EPNS_13FileInterfaceE, @function
_ZN3tga7EncoderC2EPNS_13FileInterfaceE:
.LFB1615:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
1:	call	mcount
	movq	%rsi, (%rdi)
	movb	$0, 8(%rdi)
	addq	$16, %rdi
	call	_ZN3tga7details13ImageIteratorC1Ev
	popq	%rbp
	.cfi_def_cfa 7, 8
	ret
	.cfi_endproc
.LFE1615:
	.size	_ZN3tga7EncoderC2EPNS_13FileInterfaceE, .-_ZN3tga7EncoderC2EPNS_13FileInterfaceE
	.globl	_ZN3tga7EncoderC1EPNS_13FileInterfaceE
	.set	_ZN3tga7EncoderC1EPNS_13FileInterfaceE,_ZN3tga7EncoderC2EPNS_13FileInterfaceE
	.align 2
	.globl	_ZN3tga7Encoder6write8Eh
	.type	_ZN3tga7Encoder6write8Eh, @function
_ZN3tga7Encoder6write8Eh:
.LFB1622:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
1:	call	mcount
	movq	(%rdi), %rdi
	movzbl	%sil, %esi
	movq	(%rdi), %rax
	call	*48(%rax)
	popq	%rbp
	.cfi_def_cfa 7, 8
	ret
	.cfi_endproc
.LFE1622:
	.size	_ZN3tga7Encoder6write8Eh, .-_ZN3tga7Encoder6write8Eh
	.section	.rodata
.LC0:
	.string	""
	.string	""
	.string	""
	.string	""
	.string	""
	.string	""
	.string	""
	.string	""
	.string	"TRUEVISION-XFILE."
	.string	""
	.text
	.align 2
	.globl	_ZN3tga7Encoder11writeFooterEv
	.type	_ZN3tga7Encoder11writeFooterEv, @function
_ZN3tga7Encoder11writeFooterEv:
.LFB1618:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
	pushq	%r13
	pushq	%r12
	pushq	%rbx
	subq	$8, %rsp
	.cfi_offset 13, -24
	.cfi_offset 12, -32
	.cfi_offset 3, -40
1:	call	mcount
	movq	%rdi, %r12
	movl	$.LC0, %ebx
	movl	$.LC0+26, %r13d
.L4:
	movzbl	(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder6write8Eh
	addq	$1, %rbx
	cmpq	%r13, %rbx
	jne	.L4
	addq	$8, %rsp
	popq	%rbx
	popq	%r12
	popq	%r13
	popq	%rbp
	.cfi_def_cfa 7, 8
	ret
	.cfi_endproc
.LFE1618:
	.size	_ZN3tga7Encoder11writeFooterEv, .-_ZN3tga7Encoder11writeFooterEv
	.section	.text._ZN3tga7Encoder11write8ColorEj,"axG",@progbits,_ZN3tga7Encoder11write8ColorEj,comdat
	.align 2
	.weak	_ZN3tga7Encoder11write8ColorEj
	.type	_ZN3tga7Encoder11write8ColorEj, @function
_ZN3tga7Encoder11write8ColorEj:
.LFB1382:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
1:	call	mcount
	movzbl	%sil, %esi
	call	_ZN3tga7Encoder6write8Eh
	popq	%rbp
	.cfi_def_cfa 7, 8
	ret
	.cfi_endproc
.LFE1382:
	.size	_ZN3tga7Encoder11write8ColorEj, .-_ZN3tga7Encoder11write8ColorEj
	.text
	.align 2
	.globl	_ZN3tga7Encoder10write24RgbEj
	.type	_ZN3tga7Encoder10write24RgbEj, @function
_ZN3tga7Encoder10write24RgbEj:
.LFB1626:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
	pushq	%r12
	pushq	%rbx
	.cfi_offset 12, -24
	.cfi_offset 3, -32
1:	call	mcount
	movq	%rdi, %r12
	movl	%esi, %ebx
	shrl	$16, %esi
	movzbl	%sil, %esi
	call	_ZN3tga7Encoder6write8Eh
	movzbl	%bh, %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder6write8Eh
	movzbl	%bl, %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder6write8Eh
	popq	%rbx
	popq	%r12
	popq	%rbp
	.cfi_def_cfa 7, 8
	ret
	.cfi_endproc
.LFE1626:
	.size	_ZN3tga7Encoder10write24RgbEj, .-_ZN3tga7Encoder10write24RgbEj
	.align 2
	.globl	_ZN3tga7Encoder10write32RgbEj
	.type	_ZN3tga7Encoder10write32RgbEj, @function
_ZN3tga7Encoder10write32RgbEj:
.LFB1627:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
	pushq	%r12
	pushq	%rbx
	.cfi_offset 12, -24
	.cfi_offset 3, -32
1:	call	mcount
	movq	%rdi, %r12
	movl	%esi, %ebx
	shrl	$16, %esi
	movzbl	%sil, %esi
	call	_ZN3tga7Encoder6write8Eh
	movzbl	%bh, %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder6write8Eh
	movzbl	%bl, %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder6write8Eh
	shrl	$24, %ebx
	movl	%ebx, %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder6write8Eh
	popq	%rbx
	popq	%r12
	popq	%rbp
	.cfi_def_cfa 7, 8
	ret
	.cfi_endproc
.LFE1627:
	.size	_ZN3tga7Encoder10write32RgbEj, .-_ZN3tga7Encoder10write32RgbEj
	.align 2
	.globl	_ZN3tga7Encoder7write16Et
	.type	_ZN3tga7Encoder7write16Et, @function
_ZN3tga7Encoder7write16Et:
.LFB1623:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
	pushq	%r12
	pushq	%rbx
	.cfi_offset 12, -24
	.cfi_offset 3, -32
1:	call	mcount
	movq	%rdi, %r12
	movl	%esi, %ebx
	movq	(%rdi), %rdi
	movzbl	%sil, %esi
	movq	(%rdi), %rax
	call	*48(%rax)
	movq	(%r12), %rdi
	movzbl	%bh, %esi
	movq	(%rdi), %rax
	call	*48(%rax)
	popq	%rbx
	popq	%r12
	popq	%rbp
	.cfi_def_cfa 7, 8
	ret
	.cfi_endproc
.LFE1623:
	.size	_ZN3tga7Encoder7write16Et, .-_ZN3tga7Encoder7write16Et
	.align 2
	.globl	_ZN3tga7Encoder10write16RgbEj
	.type	_ZN3tga7Encoder10write16RgbEj, @function
_ZN3tga7Encoder10write16RgbEj:
.LFB1625:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
1:	call	mcount
	movl	%esi, %eax
	shrb	$3, %sil
	sall	$10, %esi
	movl	%eax, %edx
	shrl	$19, %edx
	andl	$31, %edx
	orl	%edx, %esi
	movl	%eax, %edx
	shrl	$6, %edx
	andl	$992, %edx
	orl	%edx, %esi
	movl	$0, %edx
	cmpb	$0, 8(%rdi)
	je	.L11
	shrl	$31, %eax
	sall	$15, %eax
	movl	%eax, %edx
.L11:
	orl	%edx, %esi
	movzwl	%si, %esi
	call	_ZN3tga7Encoder7write16Et
	popq	%rbp
	.cfi_def_cfa 7, 8
	ret
	.cfi_endproc
.LFE1625:
	.size	_ZN3tga7Encoder10write16RgbEj, .-_ZN3tga7Encoder10write16RgbEj
	.section	.rodata.str1.8,"aMS",@progbits,1
	.align 8
.LC1:
	.string	"void tga::Encoder::writeHeader(const tga::Header&)"
	.section	.rodata.str1.1,"aMS",@progbits,1
.LC2:
	.string	"TEX/encoder.cpp"
	.section	.rodata.str1.8
	.align 8
.LC3:
	.string	"header.colormapLength == header.colormap.size()"
	.section	.rodata.str1.1
.LC4:
	.string	"header.colormapLength == 0"
	.text
	.align 2
	.globl	_ZN3tga7Encoder11writeHeaderERKNS_6HeaderE
	.type	_ZN3tga7Encoder11writeHeaderERKNS_6HeaderE, @function
_ZN3tga7Encoder11writeHeaderERKNS_6HeaderE:
.LFB1617:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
	pushq	%r13
	pushq	%r12
	pushq	%rbx
	subq	$8, %rsp
	.cfi_offset 13, -24
	.cfi_offset 12, -32
	.cfi_offset 3, -40
1:	call	mcount
	movq	%rdi, %r12
	movq	%rsi, %rbx
	movzbl	(%rsi), %esi
	call	_ZN3tga7Encoder6write8Eh
	movzbl	1(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder6write8Eh
	movzbl	2(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder6write8Eh
	movzwl	4(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder7write16Et
	movzwl	6(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder7write16Et
	movzbl	8(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder6write8Eh
	movzwl	10(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder7write16Et
	movzwl	12(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder7write16Et
	movzwl	14(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder7write16Et
	movzwl	16(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder7write16Et
	movzbl	18(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder6write8Eh
	movzbl	19(%rbx), %esi
	movq	%r12, %rdi
	call	_ZN3tga7Encoder6write8Eh
	movzbl	18(%rbx), %eax
	subl	$16, %eax
	testb	$-17, %al
	sete	8(%r12)
	movzwl	6(%rbx), %ecx
	movq	56(%rbx), %rdx
	movq	64(%rbx), %rax
	subq	%rdx, %rax
	sarq	$2, %rax
	movzwl	%cx, %esi
	cmpl	%eax, %esi
	jne	.L25
	cmpb	$1, 1(%rbx)
	je	.L26
	testw	%cx, %cx
	jne	.L27
.L13:
	addq	$8, %rsp
	popq	%rbx
	popq	%r12
	popq	%r13
	popq	%rbp
	.cfi_remember_state
	.cfi_def_cfa 7, 8
	ret
.L25:
	.cfi_restore_state
	movl	$.LC1, %ecx
	movl	$50, %edx
	movl	$.LC2, %esi
	movl	$.LC3, %edi
	call	__assert_fail
.L26:
	testl	%eax, %eax
	jle	.L13
	movl	$0, %r13d
	jmp	.L22
.L18:
	cmpb	$32, %al
	jne	.L19
	movq	%r12, %rdi
	call	_ZN3tga7Encoder10write32RgbEj
	jmp	.L19
.L17:
	movq	%r12, %rdi
	call	_ZN3tga7Encoder10write24RgbEj
.L19:
	movq	56(%rbx), %rdx
	addq	$1, %r13
	movq	64(%rbx), %rax
	subq	%rdx, %rax
	sarq	$2, %rax
	cmpl	%r13d, %eax
	jle	.L13
.L22:
	movl	(%rdx,%r13,4), %esi
	movzbl	8(%rbx), %eax
	cmpb	$24, %al
	je	.L17
	ja	.L18
	subl	$15, %eax
	cmpb	$1, %al
	ja	.L19
	movq	%r12, %rdi
	call	_ZN3tga7Encoder10write16RgbEj
	jmp	.L19
.L27:
	movl	$.LC1, %ecx
	movl	$65, %edx
	movl	$.LC2, %esi
	movl	$.LC4, %edi
	call	__assert_fail
	.cfi_endproc
.LFE1617:
	.size	_ZN3tga7Encoder11writeHeaderERKNS_6HeaderE, .-_ZN3tga7Encoder11writeHeaderERKNS_6HeaderE
	.align 2
	.globl	_ZN3tga7Encoder7write32Ej
	.type	_ZN3tga7Encoder7write32Ej, @function
_ZN3tga7Encoder7write32Ej:
.LFB1624:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
	pushq	%r12
	pushq	%rbx
	.cfi_offset 12, -24
	.cfi_offset 3, -32
1:	call	mcount
	movq	%rdi, %r12
	movl	%esi, %ebx
	movq	(%rdi), %rdi
	movzbl	%sil, %esi
	movq	(%rdi), %rax
	call	*48(%rax)
	movq	(%r12), %rdi
	movzbl	%bh, %esi
	movq	(%rdi), %rax
	call	*48(%rax)
	movq	(%r12), %rdi
	movl	%ebx, %esi
	shrl	$16, %esi
	movzbl	%sil, %esi
	movq	(%rdi), %rax
	call	*48(%rax)
	movq	(%r12), %rdi
	shrl	$24, %ebx
	movl	%ebx, %esi
	movq	(%rdi), %rax
	call	*48(%rax)
	popq	%rbx
	popq	%r12
	popq	%rbp
	.cfi_def_cfa 7, 8
	ret
	.cfi_endproc
.LFE1624:
	.size	_ZN3tga7Encoder7write32Ej, .-_ZN3tga7Encoder7write32Ej
	.section	.rodata._ZN3tga7Encoder16writeRleScanlineIhEEviRKNS_5ImageEMS0_FvjE.str1.8,"aMS",@progbits,1
	.align 8
.LC5:
	.string	"void tga::Encoder::writeRleScanline(int, const tga::Image&, void (tga::Encoder::*)(tga::color_t)) [with T = unsigned char; tga::color_t = unsigned int]"
	.section	.rodata._ZN3tga7Encoder16writeRleScanlineIhEEviRKNS_5ImageEMS0_FvjE.str1.1,"aMS",@progbits,1
.LC6:
	.string	"n >= 1 && n <= 128"
.LC7:
	.string	"c == c2"
.LC8:
	.string	"x == w"
	.section	.text._ZN3tga7Encoder16writeRleScanlineIhEEviRKNS_5ImageEMS0_FvjE,"axG",@progbits,_ZN3tga7Encoder16writeRleScanlineIhEEviRKNS_5ImageEMS0_FvjE,comdat
	.align 2
	.weak	_ZN3tga7Encoder16writeRleScanlineIhEEviRKNS_5ImageEMS0_FvjE
	.type	_ZN3tga7Encoder16writeRleScanlineIhEEviRKNS_5ImageEMS0_FvjE, @function
_ZN3tga7Encoder16writeRleScanlineIhEEviRKNS_5ImageEMS0_FvjE:
.LFB1843:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
	pushq	%r15
	pushq	%r14
	pushq	%r13
	pushq	%r12
	pushq	%rbx
	subq	$152, %rsp
	.cfi_offset 15, -24
	.cfi_offset 14, -32
	.cfi_offset 13, -40
	.cfi_offset 12, -48
	.cfi_offset 3, -56
1:	call	mcount
	movl	%esi, -168(%rbp)
	movq	%rdx, -128(%rbp)
	movq	%rcx, -136(%rbp)
	movq	%r8, -112(%rbp)
	testl	%esi, %esi
	jle	.L52
	movl	$0, -120(%rbp)
	leaq	16(%rdi), %r15
	movq	%rdi, %r8
	jmp	.L50
.L53:
	movl	%r12d, %ebx
	jmp	.L32
.L64:
	movl	-116(%rbp), %r12d
	movl	-148(%rbp), %r11d
	movl	-152(%rbp), %r9d
	movl	-156(%rbp), %r8d
	movl	%r13d, %edi
	movq	-144(%rbp), %r13
	movl	-160(%rbp), %esi
	movl	-164(%rbp), %ecx
	movq	-176(%rbp), %rdx
.L32:
	movl	-104(%rbp), %eax
	subl	%eax, %ebx
	movq	-128(%rbp), %rax
	movl	8(%rax), %eax
	movl	%ebx, %r10d
	imull	%eax, %r10d
	addl	$1, %eax
	cmpl	%r10d, %eax
	jb	.L65
	movq	%r13, -96(%rbp)
	movl	%r11d, -88(%rbp)
	movl	%r9d, -84(%rbp)
	movl	%r8d, -80(%rbp)
	movl	%edi, -76(%rbp)
	movl	%esi, -72(%rbp)
	movl	%ecx, -68(%rbp)
	movq	%rdx, -64(%rbp)
	cmpl	%r12d, %r14d
	je	.L66
.L37:
	movq	-64(%rbp), %rax
	movzbl	(%rax), %r15d
	leaq	-96(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	movl	%r12d, -104(%rbp)
	addl	$1, %r12d
	movq	-96(%rbp), %r13
	movl	-88(%rbp), %r11d
	movl	-84(%rbp), %r9d
	movl	-80(%rbp), %r8d
	movl	-76(%rbp), %edi
	movl	-72(%rbp), %esi
	movl	-68(%rbp), %ecx
	movq	-64(%rbp), %rdx
	cmpl	%r12d, %r14d
	jle	.L53
	movl	%r12d, %ebx
	movl	%r12d, -116(%rbp)
	movq	%r13, -144(%rbp)
	movl	%r11d, -148(%rbp)
	movl	%r9d, -152(%rbp)
	movl	%r8d, -156(%rbp)
	movl	%edi, %r13d
	movl	%esi, -160(%rbp)
	movl	%ecx, -164(%rbp)
	movq	%rdx, -176(%rbp)
.L33:
	movq	-64(%rbp), %rax
	movzbl	(%rax), %r12d
	leaq	-96(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	cmpb	%r12b, %r15b
	jne	.L64
	addl	$1, %ebx
	cmpl	%ebx, %r14d
	jne	.L33
	movl	-116(%rbp), %r12d
	movl	-148(%rbp), %r11d
	movl	-152(%rbp), %r9d
	movl	-156(%rbp), %r8d
	movl	%r13d, %edi
	movq	-144(%rbp), %r13
	movl	-160(%rbp), %esi
	movl	-164(%rbp), %ecx
	movq	-176(%rbp), %rdx
	movl	%r14d, %ebx
	jmp	.L32
.L65:
	movl	%ebx, %r10d
	movq	-184(%rbp), %r8
	movq	-192(%rbp), %r15
	movl	-104(%rbp), %r13d
	movl	-120(%rbp), %eax
	subl	%eax, %r13d
	testl	%r13d, %r13d
	jle	.L36
.L35:
	movl	%r13d, -116(%rbp)
	movl	%r10d, -144(%rbp)
	movq	%r8, %r14
	movq	-136(%rbp), %r13
	movq	%r15, -104(%rbp)
	jmp	.L43
.L66:
	movq	-184(%rbp), %r8
	movq	-192(%rbp), %r15
	movl	-168(%rbp), %r13d
	movl	-120(%rbp), %eax
	subl	%eax, %r13d
	testl	%r13d, %r13d
	jle	.L38
	movl	$0, %r10d
	jmp	.L35
.L68:
	movl	$.LC5, %ecx
	movl	$181, %edx
	movl	$.LC2, %esi
	movl	$.LC6, %edi
	call	__assert_fail
.L41:
	call	*%rax
	addl	$1, %r12d
	cmpl	%r12d, %r15d
	je	.L40
.L42:
	movq	48(%r14), %rax
	movzbl	(%rax), %ebx
	movq	-104(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	movzbl	%bl, %esi
	movq	-112(%rbp), %rax
	leaq	(%r14,%rax), %rdi
	movq	%r13, %rax
	testb	$1, %r13b
	je	.L41
	movq	(%rdi), %rax
	movq	-1(%rax,%r13), %rax
	jmp	.L41
.L40:
	subl	%r15d, -116(%rbp)
	movl	-116(%rbp), %eax
	addl	%r15d, -120(%rbp)
	testl	%eax, %eax
	jle	.L67
.L43:
	movl	$128, %r15d
	movl	-116(%rbp), %eax
	cmpl	%r15d, %eax
	cmovle	%eax, %r15d
	leal	-1(%r15), %eax
	cmpl	$127, %eax
	ja	.L68
	leal	-1(%r15), %esi
	movzbl	%sil, %esi
	movq	%r14, %rdi
	call	_ZN3tga7Encoder6write8Eh
	cmpl	$0, -116(%rbp)
	jle	.L40
	movl	$0, %r12d
	jmp	.L42
.L67:
	movl	-144(%rbp), %r10d
	movq	%r14, %r8
	movq	-104(%rbp), %r15
	movq	-128(%rbp), %rax
	movl	8(%rax), %edx
	movl	%r10d, %ecx
	imull	%edx, %ecx
	addl	$1, %edx
	cmpl	%ecx, %edx
	jnb	.L38
.L36:
	movl	%r10d, -116(%rbp)
	movq	%r15, -104(%rbp)
	movq	%r8, %r15
	jmp	.L49
.L70:
	movl	$.LC5, %ecx
	movl	$201, %edx
	movl	$.LC2, %esi
	movl	$.LC7, %edi
	call	__assert_fail
.L71:
	movl	$.LC5, %ecx
	movl	$204, %edx
	movl	$.LC2, %esi
	movl	$.LC6, %edi
	call	__assert_fail
.L48:
	movl	%r14d, %esi
	call	*%rax
	subl	%r13d, -116(%rbp)
	movl	-116(%rbp), %ecx
	addl	%r13d, -120(%rbp)
	movq	-128(%rbp), %rax
	movl	8(%rax), %eax
	movl	%ecx, %edx
	imull	%eax, %edx
	addl	$1, %eax
	cmpl	%edx, %eax
	jnb	.L69
.L49:
	movl	$128, %r13d
	movl	-116(%rbp), %ebx
	cmpl	%r13d, %ebx
	cmovle	%ebx, %r13d
	movq	48(%r15), %rax
	movzbl	(%rax), %r14d
	movq	-104(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	movzbl	%r14b, %r14d
	cmpl	$1, %ebx
	jle	.L44
	movl	$1, %r12d
.L46:
	movq	48(%r15), %rax
	movzbl	(%rax), %ebx
	movq	-104(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	movzbl	%bl, %ebx
	cmpl	%ebx, %r14d
	jne	.L70
	addl	$1, %r12d
	cmpl	%r13d, %r12d
	jl	.L46
.L44:
	leal	-1(%r13), %eax
	cmpl	$127, %eax
	ja	.L71
	leal	-1(%r13), %esi
	orl	$-128, %esi
	movzbl	%sil, %esi
	movq	%r15, %rdi
	call	_ZN3tga7Encoder6write8Eh
	movq	-112(%rbp), %rax
	leaq	(%r15,%rax), %rdi
	movq	-136(%rbp), %rdx
	movq	%rdx, %rax
	testb	$1, %dl
	je	.L48
	movq	(%rdi), %rax
	movq	-1(%rax,%rdx), %rax
	jmp	.L48
.L69:
	movq	%r15, %r8
	movq	-104(%rbp), %r15
.L38:
	movl	-120(%rbp), %ecx
	cmpl	%ecx, -168(%rbp)
	jle	.L30
.L50:
	movdqu	16(%r8), %xmm0
	movaps	%xmm0, -96(%rbp)
	movdqu	32(%r8), %xmm1
	movaps	%xmm1, -80(%rbp)
	movq	48(%r8), %rdx
	movq	%rdx, -64(%rbp)
	movl	-168(%rbp), %r14d
	movl	-120(%rbp), %eax
	cmpl	%eax, %r14d
	jle	.L31
	movl	%eax, %r12d
	movq	%r8, -184(%rbp)
	movq	%r15, -192(%rbp)
	jmp	.L37
.L52:
	movl	$0, -120(%rbp)
.L30:
	movl	-120(%rbp), %ecx
	cmpl	%ecx, -168(%rbp)
	jne	.L72
	addq	$152, %rsp
	popq	%rbx
	popq	%r12
	popq	%r13
	popq	%r14
	popq	%r15
	popq	%rbp
	.cfi_remember_state
	.cfi_def_cfa 7, 8
	ret
.L72:
	.cfi_restore_state
	movl	$.LC5, %ecx
	movl	$211, %edx
	movl	$.LC2, %esi
	movl	$.LC8, %edi
	call	__assert_fail
.L31:
	movl	-168(%rbp), %r13d
	movl	-120(%rbp), %eax
	subl	%eax, %r13d
	testl	%r13d, %r13d
	jle	.L30
	movl	$0, %r10d
	jmp	.L35
	.cfi_endproc
.LFE1843:
	.size	_ZN3tga7Encoder16writeRleScanlineIhEEviRKNS_5ImageEMS0_FvjE, .-_ZN3tga7Encoder16writeRleScanlineIhEEviRKNS_5ImageEMS0_FvjE
	.section	.rodata._ZN3tga7Encoder16writeRleScanlineIjEEviRKNS_5ImageEMS0_FvjE.str1.8,"aMS",@progbits,1
	.align 8
.LC9:
	.string	"void tga::Encoder::writeRleScanline(int, const tga::Image&, void (tga::Encoder::*)(tga::color_t)) [with T = unsigned int; tga::color_t = unsigned int]"
	.section	.text._ZN3tga7Encoder16writeRleScanlineIjEEviRKNS_5ImageEMS0_FvjE,"axG",@progbits,_ZN3tga7Encoder16writeRleScanlineIjEEviRKNS_5ImageEMS0_FvjE,comdat
	.align 2
	.weak	_ZN3tga7Encoder16writeRleScanlineIjEEviRKNS_5ImageEMS0_FvjE
	.type	_ZN3tga7Encoder16writeRleScanlineIjEEviRKNS_5ImageEMS0_FvjE, @function
_ZN3tga7Encoder16writeRleScanlineIjEEviRKNS_5ImageEMS0_FvjE:
.LFB1845:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
	pushq	%r15
	pushq	%r14
	pushq	%r13
	pushq	%r12
	pushq	%rbx
	subq	$152, %rsp
	.cfi_offset 15, -24
	.cfi_offset 14, -32
	.cfi_offset 13, -40
	.cfi_offset 12, -48
	.cfi_offset 3, -56
1:	call	mcount
	movl	%esi, -168(%rbp)
	movq	%rdx, -128(%rbp)
	movq	%rcx, -136(%rbp)
	movq	%r8, -112(%rbp)
	testl	%esi, %esi
	jle	.L96
	movl	$0, -120(%rbp)
	leaq	16(%rdi), %r15
	movq	%rdi, %r8
	jmp	.L94
.L97:
	movl	%r12d, %ebx
	jmp	.L76
.L108:
	movl	-116(%rbp), %r12d
	movl	-148(%rbp), %r11d
	movl	-152(%rbp), %r9d
	movl	-156(%rbp), %r8d
	movl	%r13d, %edi
	movq	-144(%rbp), %r13
	movl	-160(%rbp), %esi
	movl	-164(%rbp), %ecx
	movq	-176(%rbp), %rdx
.L76:
	movl	-104(%rbp), %eax
	subl	%eax, %ebx
	movq	-128(%rbp), %rax
	movl	8(%rax), %eax
	movl	%ebx, %r10d
	imull	%eax, %r10d
	addl	$1, %eax
	cmpl	%r10d, %eax
	jb	.L109
	movq	%r13, -96(%rbp)
	movl	%r11d, -88(%rbp)
	movl	%r9d, -84(%rbp)
	movl	%r8d, -80(%rbp)
	movl	%edi, -76(%rbp)
	movl	%esi, -72(%rbp)
	movl	%ecx, -68(%rbp)
	movq	%rdx, -64(%rbp)
	cmpl	%r12d, %r14d
	je	.L110
.L81:
	movq	-64(%rbp), %rax
	movl	(%rax), %r15d
	leaq	-96(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	movl	%r12d, -104(%rbp)
	addl	$1, %r12d
	movq	-96(%rbp), %r13
	movl	-88(%rbp), %r11d
	movl	-84(%rbp), %r9d
	movl	-80(%rbp), %r8d
	movl	-76(%rbp), %edi
	movl	-72(%rbp), %esi
	movl	-68(%rbp), %ecx
	movq	-64(%rbp), %rdx
	cmpl	%r12d, %r14d
	jle	.L97
	movl	%r12d, %ebx
	movl	%r12d, -116(%rbp)
	movq	%r13, -144(%rbp)
	movl	%r11d, -148(%rbp)
	movl	%r9d, -152(%rbp)
	movl	%r8d, -156(%rbp)
	movl	%edi, %r13d
	movl	%esi, -160(%rbp)
	movl	%ecx, -164(%rbp)
	movq	%rdx, -176(%rbp)
.L77:
	movq	-64(%rbp), %rax
	movl	(%rax), %r12d
	leaq	-96(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	cmpl	%r12d, %r15d
	jne	.L108
	addl	$1, %ebx
	cmpl	%ebx, %r14d
	jne	.L77
	movl	-116(%rbp), %r12d
	movl	-148(%rbp), %r11d
	movl	-152(%rbp), %r9d
	movl	-156(%rbp), %r8d
	movl	%r13d, %edi
	movq	-144(%rbp), %r13
	movl	-160(%rbp), %esi
	movl	-164(%rbp), %ecx
	movq	-176(%rbp), %rdx
	movl	%r14d, %ebx
	jmp	.L76
.L109:
	movl	%ebx, %r10d
	movq	-184(%rbp), %r8
	movq	-192(%rbp), %r15
	movl	-104(%rbp), %r13d
	movl	-120(%rbp), %eax
	subl	%eax, %r13d
	testl	%r13d, %r13d
	jle	.L80
.L79:
	movl	%r13d, -116(%rbp)
	movl	%r10d, -144(%rbp)
	movq	%r8, %r13
	movq	-136(%rbp), %r12
	movq	%r15, -104(%rbp)
	jmp	.L87
.L110:
	movq	-184(%rbp), %r8
	movq	-192(%rbp), %r15
	movl	-168(%rbp), %r13d
	movl	-120(%rbp), %eax
	subl	%eax, %r13d
	testl	%r13d, %r13d
	jle	.L82
	movl	$0, %r10d
	jmp	.L79
.L112:
	movl	$.LC9, %ecx
	movl	$181, %edx
	movl	$.LC2, %esi
	movl	$.LC6, %edi
	call	__assert_fail
.L85:
	movl	%r14d, %esi
	call	*%rax
	addl	$1, %ebx
	cmpl	%ebx, %r15d
	je	.L84
.L86:
	movq	48(%r13), %rax
	movl	(%rax), %r14d
	movq	-104(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	movq	-112(%rbp), %rax
	leaq	0(%r13,%rax), %rdi
	movq	%r12, %rax
	testb	$1, %r12b
	je	.L85
	movq	(%rdi), %rax
	movq	-1(%rax,%r12), %rax
	jmp	.L85
.L84:
	subl	%r15d, -116(%rbp)
	movl	-116(%rbp), %eax
	addl	%r15d, -120(%rbp)
	testl	%eax, %eax
	jle	.L111
.L87:
	movl	$128, %r15d
	movl	-116(%rbp), %eax
	cmpl	%r15d, %eax
	cmovle	%eax, %r15d
	leal	-1(%r15), %eax
	cmpl	$127, %eax
	ja	.L112
	leal	-1(%r15), %esi
	movzbl	%sil, %esi
	movq	%r13, %rdi
	call	_ZN3tga7Encoder6write8Eh
	cmpl	$0, -116(%rbp)
	jle	.L84
	movl	$0, %ebx
	jmp	.L86
.L111:
	movl	-144(%rbp), %r10d
	movq	%r13, %r8
	movq	-104(%rbp), %r15
	movq	-128(%rbp), %rax
	movl	8(%rax), %edx
	movl	%r10d, %ecx
	imull	%edx, %ecx
	addl	$1, %edx
	cmpl	%ecx, %edx
	jnb	.L82
.L80:
	movl	%r10d, -116(%rbp)
	movq	%r8, %r14
	movq	%r15, -104(%rbp)
	jmp	.L93
.L114:
	movl	$.LC9, %ecx
	movl	$201, %edx
	movl	$.LC2, %esi
	movl	$.LC7, %edi
	call	__assert_fail
.L115:
	movl	$.LC9, %ecx
	movl	$204, %edx
	movl	$.LC2, %esi
	movl	$.LC6, %edi
	call	__assert_fail
.L92:
	movl	%r15d, %esi
	call	*%rax
	subl	%r13d, -116(%rbp)
	movl	-116(%rbp), %ecx
	addl	%r13d, -120(%rbp)
	movq	-128(%rbp), %rax
	movl	8(%rax), %eax
	movl	%ecx, %edx
	imull	%eax, %edx
	addl	$1, %eax
	cmpl	%edx, %eax
	jnb	.L113
.L93:
	movl	$128, %r13d
	movl	-116(%rbp), %ebx
	cmpl	%r13d, %ebx
	cmovle	%ebx, %r13d
	movq	48(%r14), %rax
	movl	(%rax), %r15d
	movq	-104(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	cmpl	$1, %ebx
	jle	.L88
	movl	$1, %ebx
.L90:
	movq	48(%r14), %rax
	movl	(%rax), %r12d
	movq	-104(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	cmpl	%r12d, %r15d
	jne	.L114
	addl	$1, %ebx
	cmpl	%r13d, %ebx
	jl	.L90
.L88:
	leal	-1(%r13), %eax
	cmpl	$127, %eax
	ja	.L115
	leal	-1(%r13), %esi
	orl	$-128, %esi
	movzbl	%sil, %esi
	movq	%r14, %rdi
	call	_ZN3tga7Encoder6write8Eh
	movq	-112(%rbp), %rax
	leaq	(%r14,%rax), %rdi
	movq	-136(%rbp), %rdx
	movq	%rdx, %rax
	testb	$1, %dl
	je	.L92
	movq	(%rdi), %rax
	movq	-1(%rax,%rdx), %rax
	jmp	.L92
.L113:
	movq	%r14, %r8
	movq	-104(%rbp), %r15
.L82:
	movl	-120(%rbp), %ecx
	cmpl	%ecx, -168(%rbp)
	jle	.L74
.L94:
	movdqu	16(%r8), %xmm0
	movaps	%xmm0, -96(%rbp)
	movdqu	32(%r8), %xmm1
	movaps	%xmm1, -80(%rbp)
	movq	48(%r8), %rdx
	movq	%rdx, -64(%rbp)
	movl	-168(%rbp), %r14d
	movl	-120(%rbp), %eax
	cmpl	%eax, %r14d
	jle	.L75
	movl	%eax, %r12d
	movq	%r8, -184(%rbp)
	movq	%r15, -192(%rbp)
	jmp	.L81
.L96:
	movl	$0, -120(%rbp)
.L74:
	movl	-120(%rbp), %ecx
	cmpl	%ecx, -168(%rbp)
	jne	.L116
	addq	$152, %rsp
	popq	%rbx
	popq	%r12
	popq	%r13
	popq	%r14
	popq	%r15
	popq	%rbp
	.cfi_remember_state
	.cfi_def_cfa 7, 8
	ret
.L116:
	.cfi_restore_state
	movl	$.LC9, %ecx
	movl	$211, %edx
	movl	$.LC2, %esi
	movl	$.LC8, %edi
	call	__assert_fail
.L75:
	movl	-168(%rbp), %r13d
	movl	-120(%rbp), %eax
	subl	%eax, %r13d
	testl	%r13d, %r13d
	jle	.L74
	movl	$0, %r10d
	jmp	.L79
	.cfi_endproc
.LFE1845:
	.size	_ZN3tga7Encoder16writeRleScanlineIjEEviRKNS_5ImageEMS0_FvjE, .-_ZN3tga7Encoder16writeRleScanlineIjEEviRKNS_5ImageEMS0_FvjE
	.section	.rodata.str1.8
	.align 8
.LC10:
	.string	"void tga::Encoder::writeImage(const tga::Header&, const tga::Image&, tga::Delegate*)"
	.section	.rodata.str1.1
.LC11:
	.string	"false"
	.text
	.align 2
	.globl	_ZN3tga7Encoder10writeImageERKNS_6HeaderERKNS_5ImageEPNS_8DelegateE
	.type	_ZN3tga7Encoder10writeImageERKNS_6HeaderERKNS_5ImageEPNS_8DelegateE, @function
_ZN3tga7Encoder10writeImageERKNS_6HeaderERKNS_5ImageEPNS_8DelegateE:
.LFB1619:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
	pushq	%r15
	pushq	%r14
	pushq	%r13
	pushq	%r12
	pushq	%rbx
	subq	$88, %rsp
	.cfi_offset 15, -24
	.cfi_offset 14, -32
	.cfi_offset 13, -40
	.cfi_offset 12, -48
	.cfi_offset 3, -56
1:	call	mcount
	movq	%rdi, %rbx
	movq	%rsi, %r13
	movq	%rdx, -104(%rbp)
	movq	%rcx, %r15
	movzwl	14(%rsi), %r14d
	movzwl	16(%rsi), %eax
	movl	%eax, -108(%rbp)
	leaq	-96(%rbp), %rdi
	call	_ZN3tga7details13ImageIteratorC1ERKNS_6HeaderERNS_5ImageE
	movdqa	-96(%rbp), %xmm2
	movups	%xmm2, 16(%rbx)
	movdqa	-80(%rbp), %xmm3
	movups	%xmm3, 32(%rbx)
	movq	-64(%rbp), %rax
	movq	%rax, 48(%rbx)
	cmpb	$11, 2(%r13)
	ja	.L117
	movzbl	2(%r13), %eax
	jmp	*.L120(,%rax,8)
	.section	.rodata
	.align 8
	.align 4
.L120:
	.quad	.L117
	.quad	.L122
	.quad	.L123
	.quad	.L122
	.quad	.L117
	.quad	.L117
	.quad	.L117
	.quad	.L117
	.quad	.L117
	.quad	.L119
	.quad	.L121
	.quad	.L119
	.text
.L121:
	movl	$0, %r12d
	cmpl	$0, -108(%rbp)
	jg	.L124
	jmp	.L117
.L119:
	movl	$0, %r12d
	cmpl	$0, -108(%rbp)
	jg	.L125
	jmp	.L117
.L122:
	movq	$0, -120(%rbp)
	leaq	16(%rbx), %rax
	movq	%rax, -104(%rbp)
	cmpl	$0, -108(%rbp)
	jg	.L126
	jmp	.L117
.L128:
	addq	$1, -120(%rbp)
	movq	-120(%rbp), %rax
	cmpl	%eax, -108(%rbp)
	jle	.L117
.L126:
	movl	$0, %r13d
	testl	%r14d, %r14d
	jle	.L129
.L127:
	movq	48(%rbx), %rax
	movzbl	(%rax), %r12d
	movq	-104(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	movzbl	%r12b, %esi
	movq	%rbx, %rdi
	call	_ZN3tga7Encoder6write8Eh
	addl	$1, %r13d
	cmpl	%r13d, %r14d
	jne	.L127
.L129:
	testq	%r15, %r15
	je	.L128
	pxor	%xmm0, %xmm0
	cvtsi2ssl	-120(%rbp), %xmm0
	pxor	%xmm1, %xmm1
	cvtsi2ssl	-108(%rbp), %xmm1
	divss	%xmm1, %xmm0
	cvtss2sd	%xmm0, %xmm0
	movq	(%r15), %rax
	movq	%r15, %rdi
	call	*16(%rax)
	testb	%al, %al
	jne	.L128
.L117:
	addq	$88, %rsp
	popq	%rbx
	popq	%r12
	popq	%r13
	popq	%r14
	popq	%r15
	popq	%rbp
	.cfi_remember_state
	.cfi_def_cfa 7, 8
	ret
.L130:
	.cfi_restore_state
	addq	$1, %r12
	cmpl	%r12d, -108(%rbp)
	jle	.L117
.L125:
	movl	$_ZN3tga7Encoder11write8ColorEj, %ecx
	movl	$0, %r8d
	movq	-104(%rbp), %rdx
	movl	%r14d, %esi
	movq	%rbx, %rdi
	call	_ZN3tga7Encoder16writeRleScanlineIhEEviRKNS_5ImageEMS0_FvjE
	testq	%r15, %r15
	je	.L130
	pxor	%xmm0, %xmm0
	cvtsi2ssl	%r12d, %xmm0
	pxor	%xmm1, %xmm1
	cvtsi2ssl	-108(%rbp), %xmm1
	divss	%xmm1, %xmm0
	cvtss2sd	%xmm0, %xmm0
	movq	(%r15), %rax
	movq	%r15, %rdi
	call	*16(%rax)
	testb	%al, %al
	jne	.L130
	jmp	.L117
.L123:
	movzbl	18(%r13), %eax
	cmpb	$24, %al
	je	.L131
	ja	.L132
	subl	$15, %eax
	cmpb	$1, %al
	ja	.L117
	movq	$0, -120(%rbp)
	leaq	16(%rbx), %rax
	movq	%rax, -104(%rbp)
	cmpl	$0, -108(%rbp)
	jg	.L136
	jmp	.L117
.L132:
	cmpb	$32, %al
	jne	.L117
	movq	$0, -120(%rbp)
	leaq	16(%rbx), %rax
	movq	%rax, -104(%rbp)
	cmpl	$0, -108(%rbp)
	jg	.L134
	jmp	.L117
.L131:
	movq	$0, -120(%rbp)
	leaq	16(%rbx), %rax
	movq	%rax, -104(%rbp)
	cmpl	$0, -108(%rbp)
	jg	.L135
	jmp	.L117
.L138:
	addq	$1, -120(%rbp)
	movq	-120(%rbp), %rax
	cmpl	%eax, -108(%rbp)
	jle	.L117
.L136:
	movl	$0, %r12d
	testl	%r14d, %r14d
	jle	.L139
.L137:
	movq	48(%rbx), %rax
	movl	(%rax), %r13d
	movq	-104(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	movl	%r13d, %esi
	movq	%rbx, %rdi
	call	_ZN3tga7Encoder10write16RgbEj
	addl	$1, %r12d
	cmpl	%r12d, %r14d
	jne	.L137
.L139:
	testq	%r15, %r15
	je	.L138
	pxor	%xmm0, %xmm0
	cvtsi2ssl	-120(%rbp), %xmm0
	pxor	%xmm1, %xmm1
	cvtsi2ssl	-108(%rbp), %xmm1
	divss	%xmm1, %xmm0
	cvtss2sd	%xmm0, %xmm0
	movq	(%r15), %rax
	movq	%r15, %rdi
	call	*16(%rax)
	testb	%al, %al
	jne	.L138
	jmp	.L117
.L141:
	addq	$1, -120(%rbp)
	movq	-120(%rbp), %rax
	cmpl	%eax, -108(%rbp)
	jle	.L117
.L135:
	movl	$0, %r12d
	testl	%r14d, %r14d
	jle	.L142
.L140:
	movq	48(%rbx), %rax
	movl	(%rax), %r13d
	movq	-104(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	movl	%r13d, %esi
	movq	%rbx, %rdi
	call	_ZN3tga7Encoder10write24RgbEj
	addl	$1, %r12d
	cmpl	%r12d, %r14d
	jne	.L140
.L142:
	testq	%r15, %r15
	je	.L141
	pxor	%xmm0, %xmm0
	cvtsi2ssl	-120(%rbp), %xmm0
	pxor	%xmm1, %xmm1
	cvtsi2ssl	-108(%rbp), %xmm1
	divss	%xmm1, %xmm0
	cvtss2sd	%xmm0, %xmm0
	movq	(%r15), %rax
	movq	%r15, %rdi
	call	*16(%rax)
	testb	%al, %al
	jne	.L141
	jmp	.L117
.L144:
	addq	$1, -120(%rbp)
	movq	-120(%rbp), %rax
	cmpl	%eax, -108(%rbp)
	jle	.L117
.L134:
	movl	$0, %r12d
	testl	%r14d, %r14d
	jle	.L145
.L143:
	movq	48(%rbx), %rax
	movl	(%rax), %r13d
	movq	-104(%rbp), %rdi
	call	_ZN3tga7details13ImageIterator7advanceEv
	movl	%r13d, %esi
	movq	%rbx, %rdi
	call	_ZN3tga7Encoder10write32RgbEj
	addl	$1, %r12d
	cmpl	%r12d, %r14d
	jne	.L143
.L145:
	testq	%r15, %r15
	je	.L144
	pxor	%xmm0, %xmm0
	cvtsi2ssl	-120(%rbp), %xmm0
	pxor	%xmm1, %xmm1
	cvtsi2ssl	-108(%rbp), %xmm1
	divss	%xmm1, %xmm0
	cvtss2sd	%xmm0, %xmm0
	movq	(%r15), %rax
	movq	%r15, %rdi
	call	*16(%rax)
	testb	%al, %al
	jne	.L144
	jmp	.L117
.L147:
	cmpb	$32, %al
	jne	.L148
	movl	$_ZN3tga7Encoder10write32RgbEj, %ecx
	movl	$0, %r8d
	movq	-104(%rbp), %rdx
	movl	%r14d, %esi
	movq	%rbx, %rdi
	call	_ZN3tga7Encoder16writeRleScanlineIjEEviRKNS_5ImageEMS0_FvjE
	jmp	.L151
.L146:
	movl	$_ZN3tga7Encoder10write24RgbEj, %ecx
	movl	$0, %r8d
	movq	-104(%rbp), %rdx
	movl	%r14d, %esi
	movq	%rbx, %rdi
	call	_ZN3tga7Encoder16writeRleScanlineIjEEviRKNS_5ImageEMS0_FvjE
.L151:
	testq	%r15, %r15
	je	.L152
	pxor	%xmm0, %xmm0
	cvtsi2ssl	%r12d, %xmm0
	pxor	%xmm1, %xmm1
	cvtsi2ssl	-108(%rbp), %xmm1
	divss	%xmm1, %xmm0
	cvtss2sd	%xmm0, %xmm0
	movq	(%r15), %rax
	movq	%r15, %rdi
	call	*16(%rax)
	testb	%al, %al
	je	.L117
.L152:
	addq	$1, %r12
	cmpl	%r12d, -108(%rbp)
	jle	.L117
.L124:
	movzbl	18(%r13), %eax
	cmpb	$24, %al
	je	.L146
	ja	.L147
	subl	$15, %eax
	cmpb	$1, %al
	ja	.L148
	movl	$_ZN3tga7Encoder10write16RgbEj, %ecx
	movl	$0, %r8d
	movq	-104(%rbp), %rdx
	movl	%r14d, %esi
	movq	%rbx, %rdi
	call	_ZN3tga7Encoder16writeRleScanlineIjEEviRKNS_5ImageEMS0_FvjE
	jmp	.L151
.L148:
	movl	$.LC10, %ecx
	movl	$154, %edx
	movl	$.LC2, %esi
	movl	$.LC11, %edi
	call	__assert_fail
	.cfi_endproc
.LFE1619:
	.size	_ZN3tga7Encoder10writeImageERKNS_6HeaderERKNS_5ImageEPNS_8DelegateE, .-_ZN3tga7Encoder10writeImageERKNS_6HeaderERKNS_5ImageEPNS_8DelegateE
	.ident	"GCC: (GNU) 12.2.1 20220819 (Red Hat 12.2.1-2)"
	.section	.note.GNU-stack,"",@progbits
